var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { merge, Subject } from 'rxjs';
import { Channel } from '../../Channel';
import { isWebRTCSupported, isWebSocketSupported, log } from '../../misc/util';
import { channelBuilder as proto } from '../../proto';
import { CONNECT_TIMEOUT as WEBSOCKET_TIMEOUT, WebSocketBuilder } from '../../WebSocketBuilder';
import { CONNECT_TIMEOUT as DATACHANNEL_TIMEOUT, DataChannelBuilder, } from '../dataChannelBuilder/DataChannelBuilder';
import { Service } from '../Service';
import { ConnectionError } from './ConnectionError';
import { ConnectionsInProgress } from './ConnectionsInProgress';
var CONNECT_TIMEOUT = Math.max(DATACHANNEL_TIMEOUT, WEBSOCKET_TIMEOUT) + 5000;
var RESPONSE_TIMEOUT = 2000;
var ChannelBuilder = (function (_super) {
    __extends(ChannelBuilder, _super);
    function ChannelBuilder(wc) {
        var _this = _super.call(this, ChannelBuilder.SERVICE_ID, proto.Message) || this;
        _this.wc = wc;
        _this.allStreams = _super.prototype.useAllStreams.call(_this, wc, wc.signaling);
        _this.connectsInProgress = new ConnectionsInProgress();
        _this.channelsSubject = new Subject();
        _this.onConnectionRequest = function () { return true; };
        _this.dataChannelBuilder = new DataChannelBuilder(_this.wc, _this.wc.rtcConfiguration);
        _this.myInfo = {
            wsTried: false,
            wsSupported: isWebSocketSupported(),
            dcTried: false,
            dcSupported: isWebRTCSupported(),
        };
        _this.negotiationEncoded = _super.prototype.encode.call(_this, { negotiation: { initiator: _this.myInfo } });
        if (!ChannelBuilder.connectResTrueEncoded && !ChannelBuilder.connectResFalseEncoded) {
            ChannelBuilder.connectResTrueEncoded = _super.prototype.encode.call(_this, { connectionResponse: true });
            ChannelBuilder.connectResFalseEncoded = _super.prototype.encode.call(_this, { connectionResponse: false });
        }
        _this.allStreams.message.subscribe(function (_a) {
            var streamId = _a.streamId, senderId = _a.senderId, recipientId = _a.recipientId, msg = _a.msg;
            _this.handleMessage(streamId, senderId, recipientId, msg);
        });
        _this.subscribeToChannels();
        _this.subscribeToURLandIDChange();
        return _this;
    }
    ChannelBuilder.prototype.clean = function () {
        log.channelBuilder('CLEAN call');
        this.dataChannelBuilder.clean();
        this.connectsInProgress.clean();
    };
    Object.defineProperty(ChannelBuilder.prototype, "onChannel", {
        get: function () {
            return this.channelsSubject.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    ChannelBuilder.prototype.connectOverWebChannel = function (id, cb, data) {
        if (cb === void 0) { cb = function () { }; }
        if (data === void 0) { data = new Uint8Array(); }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.connectOver(this.wc.STREAM_ID, id, cb, data)];
            });
        });
    };
    ChannelBuilder.prototype.connectOverSignaling = function (cb, data) {
        if (cb === void 0) { cb = function () { }; }
        if (data === void 0) { data = new Uint8Array(); }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.connectOver(this.wc.signaling.STREAM_ID, 0, cb, data)];
            });
        });
    };
    ChannelBuilder.prototype.connectOver = function (streamId, id, cb, data) {
        return __awaiter(this, void 0, void 0, function () {
            var connection;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        connection = this.connectsInProgress.get(id);
                        if (!!connection) return [3, 2];
                        this.allStreams.sendOver(streamId, { connectionRequest: data }, id, this.wc.myId);
                        connection = this.connectsInProgress.create(id, CONNECT_TIMEOUT, RESPONSE_TIMEOUT, function () {
                            return _this.dataChannelBuilder.clean(id);
                        });
                        return [4, connection.promise];
                    case 1:
                        _a.sent();
                        cb();
                        return [2, connection.promise];
                    case 2: throw new Error(ConnectionError.IN_PROGRESS);
                }
            });
        });
    };
    ChannelBuilder.prototype.handleMessage = function (streamId, senderId, recipientId, msg) {
        var _this = this;
        switch (msg.type) {
            case 'connectionRequest': {
                log.channelBuilder('connection Request from ', senderId);
                var connection = this.connectsInProgress.get(senderId);
                if (connection) {
                    if (senderId < this.wc.myId) {
                        connection.reject(new Error(ConnectionError.IN_PROGRESS));
                    }
                    else {
                        return;
                    }
                }
                if (this.onConnectionRequest(streamId, msg.connectionRequest)) {
                    connection = this.connectsInProgress.create(senderId, CONNECT_TIMEOUT, RESPONSE_TIMEOUT, function () { return _this.dataChannelBuilder.clean(senderId); });
                    connection.resolve();
                    log.channelBuilder('connection Response POSITIVE to ', senderId);
                    this.allStreams.sendOver(streamId, ChannelBuilder.connectResTrueEncoded, senderId, recipientId);
                }
                else {
                    log.channelBuilder('connection Response NEGATIVE to ', senderId);
                    this.allStreams.sendOver(streamId, ChannelBuilder.connectResFalseEncoded, senderId, recipientId);
                }
                break;
            }
            case 'connectionResponse': {
                log.channelBuilder('connection Response from ', senderId);
                var connection = this.connectsInProgress.get(senderId);
                if (connection) {
                    if (msg.connectionResponse) {
                        connection.resolve();
                        log.channelBuilder('Send first negotiation message to ', senderId);
                        this.allStreams.sendOver(streamId, this.negotiationEncoded, senderId, recipientId);
                    }
                    else {
                        connection.reject(new Error(ConnectionError.DENIED));
                    }
                }
                break;
            }
            case 'negotiation': {
                if (this.connectsInProgress.has(streamId, senderId)) {
                    var neg = msg.negotiation;
                    var initiator_1 = neg.initiator;
                    var passive_1 = neg.passive;
                    if (!passive_1) {
                        initiator_1.id = senderId;
                        passive_1 = Object.assign({}, this.myInfo);
                        passive_1.id = recipientId;
                    }
                    log.channelBuilder("NEGOTIATION message to proceed from " + senderId + ": ", JSON.stringify({
                        isIamInitiatore: passive_1.id === senderId,
                        passive: passive_1,
                        initiator: initiator_1,
                        senderId: senderId,
                        recipientId: recipientId,
                    }));
                    if (this.isNagotiable(initiator_1, passive_1)) {
                        this.proceedNegotiation(streamId, initiator_1, passive_1, passive_1.id === senderId).catch(function (err) {
                            _this.rejectConnection(streamId, senderId, err);
                            log.channelBuilder("NEGOTIATION with " + senderId + " FIALED: ", { passive: passive_1, initiator: initiator_1 });
                            _this.allStreams.sendOver(streamId, { negotiation: { initiator: initiator_1, passive: passive_1 } }, senderId, recipientId);
                        });
                    }
                    else {
                        this.rejectConnection(streamId, senderId, new Error(ConnectionError.NEGOTIATION_ERROR));
                    }
                }
                break;
            }
        }
    };
    ChannelBuilder.prototype.proceedNegotiation = function (streamId, initiator, passive, amIInitiator) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, me, theOther, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = __read(amIInitiator ? [initiator, passive] : [passive, initiator], 2), me = _a[0], theOther = _a[1];
                        _b = theOther.wss && !me.wsTried;
                        if (!_b) return [3, 2];
                        return [4, this.tryWs(streamId, me, theOther, amIInitiator)];
                    case 1:
                        _b = (_d.sent());
                        _d.label = 2;
                    case 2:
                        if (_b) {
                            return [2];
                        }
                        if (me.wss && !theOther.wsTried) {
                            log.channelBuilder("Prompt the other to connect over WebSocket");
                            this.allStreams.sendOver(streamId, { negotiation: { initiator: initiator, passive: passive } }, theOther.id, me.id);
                            return [2];
                        }
                        if (!(me.dcSupported && theOther.dcSupported)) return [3, 5];
                        _c = !me.dcTried;
                        if (!_c) return [3, 4];
                        return [4, this.tryDc(streamId, me, theOther, amIInitiator)];
                    case 3:
                        _c = (_d.sent());
                        _d.label = 4;
                    case 4:
                        if (_c) {
                            return [2];
                        }
                        if (!theOther.dcTried) {
                            log.channelBuilder("Prompt the other to connect over RTCDataChannel");
                            this.allStreams.sendOver(streamId, { negotiation: { initiator: initiator, passive: passive } }, theOther.id, me.id);
                            return [2];
                        }
                        _d.label = 5;
                    case 5: throw new Error(ConnectionError.NEGOTIATION_ERROR);
                }
            });
        });
    };
    ChannelBuilder.prototype.tryWs = function (streamId, me, theOther, amIInitiator) {
        return __awaiter(this, void 0, void 0, function () {
            var type, wcId, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        type = this.getType(streamId, amIInitiator);
                        wcId = type === Channel.WITH_MEMBER ? theOther.wcId : this.wc.myId;
                        return [4, this.wc.webSocketBuilder.connect(theOther.wss, type, theOther.id, me.id, wcId)];
                    case 1:
                        _a.sent();
                        log.channelBuilder("New WebSocket connection with " + theOther.id);
                        return [2, true];
                    case 2:
                        err_1 = _a.sent();
                        if (err_1.message !== 'clean') {
                            log.channelBuilder("WebSocket failed with " + theOther.id, err_1);
                            me.wsTried = true;
                            return [2, false];
                        }
                        else {
                            return [2, true];
                        }
                        return [3, 3];
                    case 3: return [2];
                }
            });
        });
    };
    ChannelBuilder.prototype.tryDc = function (streamId, me, theOther, amIInitiator) {
        return __awaiter(this, void 0, void 0, function () {
            var type, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        type = this.getType(streamId, amIInitiator);
                        return [4, this.dataChannelBuilder.connect(theOther.id, me.id, type)];
                    case 1:
                        _a.sent();
                        log.channelBuilder("New RTCDataChannel with " + theOther.id);
                        return [2, true];
                    case 2:
                        err_2 = _a.sent();
                        if (err_2.message !== 'clean') {
                            log.channelBuilder("RTCDataChannel failed with " + theOther.id, err_2);
                            me.dcTried = true;
                            return [2, false];
                        }
                        else {
                            return [2, true];
                        }
                        return [3, 3];
                    case 3: return [2];
                }
            });
        });
    };
    ChannelBuilder.prototype.getType = function (streamId, amIInitiator) {
        if (streamId === this.wc.STREAM_ID) {
            return Channel.WITH_INTERNAL;
        }
        return amIInitiator ? Channel.WITH_MEMBER : Channel.WITH_JOINING;
    };
    ChannelBuilder.prototype.isNagotiable = function (peerInfo1, peerInfo2) {
        return ((peerInfo1.wss && !peerInfo2.wsTried) ||
            (peerInfo2.wss && !peerInfo1.wsTried) ||
            (peerInfo1.dcSupported && peerInfo2.dcSupported && (!peerInfo1.dcTried || !peerInfo2.dcTried)));
    };
    ChannelBuilder.prototype.subscribeToChannels = function () {
        var _this = this;
        merge(this.dataChannelBuilder.channels, this.wc.webSocketBuilder.channels).subscribe(function (_a) {
            var id = _a.id, channel = _a.channel;
            channel.init.then(function () {
                log.channelBuilder('NEW Channel from ', JSON.stringify({ type: channel.type, id: id }));
                var connection = _this.connectsInProgress.get(id);
                if (connection) {
                    log.channelBuilder('RESOLVE this NEW Channel');
                    connection.resolve();
                }
                else {
                    log.channelBuilder('this NEW Channel NOT FOUND');
                }
                _this.channelsSubject.next(channel);
            });
        });
    };
    ChannelBuilder.prototype.subscribeToURLandIDChange = function () {
        var _this = this;
        WebSocketBuilder.listenUrl.subscribe(function (url) {
            if (url) {
                _this.myInfo.wss = url;
                _this.negotiationEncoded = _super.prototype.encode.call(_this, { negotiation: { initiator: _this.myInfo } });
            }
        });
        this.wc.onIdChange.subscribe(function (id) {
            _this.myInfo.wcId = _this.wc.id;
            _this.negotiationEncoded = _super.prototype.encode.call(_this, { negotiation: { initiator: _this.myInfo } });
        });
    };
    ChannelBuilder.prototype.rejectConnection = function (streamId, senderId, err) {
        var connection = this.connectsInProgress.get(senderId);
        if (connection) {
            connection.reject(err);
        }
    };
    ChannelBuilder.SERVICE_ID = 74;
    return ChannelBuilder;
}(Service));
export { ChannelBuilder };
//# sourceMappingURL=ChannelBuilder.js.map