var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Subject } from 'rxjs';
import { Channel } from '../../Channel';
import '../../misc/env';
import { env } from '../../misc/env';
import { log } from '../../misc/util';
import { dataChannelBuilder as proto } from '../../proto';
import { Service } from '../Service';
import { Remote } from './Remote';
export var CONNECT_TIMEOUT = 9000;
var DataChannelBuilder = (function (_super) {
    __extends(DataChannelBuilder, _super);
    function DataChannelBuilder(wc, rtcConfiguration) {
        var _this = _super.call(this, DataChannelBuilder.SERVICE_ID, proto.Message) || this;
        _this.wc = wc;
        _this.allStreams = _super.prototype.useAllStreams.call(_this, wc, wc.signaling);
        _this.rtcConfiguration = rtcConfiguration;
        _this.channelsSubject = new Subject();
        _this.remotes = new Map();
        _this.allStreams.message.subscribe(function (_a) {
            var streamId = _a.streamId, senderId = _a.senderId, recipientId = _a.recipientId, msg = _a.msg;
            var remote = _this.remotes.get(senderId);
            if (remote && remote.finalMessageReceived) {
                remote.clean(false);
                remote = undefined;
            }
            if (!remote) {
                if (msg.type && (msg.type === 'offer' || msg.type === 'candidate')) {
                    try {
                        remote = _this.createRemote(streamId, senderId, recipientId, true);
                    }
                    catch (err) {
                        return;
                    }
                }
                else {
                    return;
                }
            }
            remote.handleMessage(msg);
        });
        return _this;
    }
    Object.defineProperty(DataChannelBuilder.prototype, "channels", {
        get: function () {
            return this.channelsSubject.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    DataChannelBuilder.prototype.connect = function (targetId, myId, type) {
        return __awaiter(this, void 0, void 0, function () {
            var streamId, remote, remoteType, dc, offerInit, offer, channel;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        log.webrtc('connectWith call', { targetId: targetId, myId: myId, type: type });
                        streamId = type === Channel.WITH_INTERNAL ? this.wc.STREAM_ID : this.wc.signaling.STREAM_ID;
                        remote = this.remotes.get(targetId);
                        if (remote) {
                            remote.clean();
                        }
                        else {
                            remote = this.createRemote(streamId, targetId, myId);
                        }
                        remoteType = Channel.remoteType(type);
                        dc = remote.pc.createDataChannel("{\"id\":" + this.wc.myId + ",\"type\":" + remoteType + "}");
                        return [4, remote.pc.createOffer()];
                    case 1:
                        offerInit = _a.sent();
                        return [4, remote.pc.setLocalDescription(offerInit)];
                    case 2:
                        _a.sent();
                        offer = remote.pc.localDescription.sdp;
                        this.allStreams.sendOver(streamId, { offer: offer }, targetId, myId);
                        remote.sdpIsSent();
                        return [4, new Promise(function (resolve, reject) {
                                remote.onError = function (err) { return reject(err); };
                                dc.onopen = function () {
                                    remote.dataChannelOpen(dc);
                                    resolve(new Channel(_this.wc, dc, type, targetId, remote.pc));
                                };
                            })];
                    case 3:
                        channel = (_a.sent());
                        this.channelsSubject.next({ id: targetId, channel: channel });
                        return [2];
                }
            });
        });
    };
    DataChannelBuilder.prototype.clean = function (id) {
        if (id) {
            var remote = this.remotes.get(id);
            if (remote) {
                remote.clean(false);
            }
        }
        else {
            this.remotes.forEach(function (remote) { return remote.onError(new Error('clean')); });
        }
    };
    DataChannelBuilder.prototype.createRemote = function (streamId, recipientId, senderId, passive) {
        var _this = this;
        if (passive === void 0) { passive = false; }
        var remote = new Remote(recipientId, new env.RTCPeerConnection(this.rtcConfiguration), function (msg) { return _this.allStreams.sendOver(streamId, msg, recipientId, senderId); }, this.remotes, CONNECT_TIMEOUT);
        if (passive) {
            log.webrtc("create a new remote object with " + recipientId + " - PASSIVE");
            var pc = remote.pc;
            pc.ondatachannel = function (_a) {
                var dc = _a.channel;
                var _b = JSON.parse(dc.label), id = _b.id, type = _b.type;
                dc.onopen = function () {
                    remote.dataChannelOpen(dc);
                    var channel = new Channel(_this.wc, dc, type, id, remote.pc);
                    _this.channelsSubject.next({ id: recipientId, channel: channel });
                };
            };
        }
        else {
            log.webrtc("create a new remote object with " + recipientId + " - INITIATOR");
        }
        return remote;
    };
    DataChannelBuilder.SERVICE_ID = 7431;
    return DataChannelBuilder;
}(Service));
export { DataChannelBuilder };
//# sourceMappingURL=DataChannelBuilder.js.map